#!/bin/bash
file=$1
if [ ! -r $file ]; then
    echo "file not found: " $1
    exit;
fi
# Look for DENOM statements; color information will be right above them
traceList=`cat $1 | grep -B2 -e 'DATA DENOM(' -e 'BEGIN CODE' | grep -v DATA | grep -v BEGIN | grep -v COMMON | grep -v '\-\-' | grep T | sed s/"C     "/"PROC "/ | sed s/Tr//g | sed s/T//g | sed s/") ("/,0,/g | sed s/"("/" BEGIN "/ | sed s/")"/" END "/ | sed s/","/" "/g`
# Now traceList contains entries like: PROC 1 BEGIN 1 2 0 4 3
# (The zero separates two separate traces)
nExternal=`cat $1 | grep -m1 "NEXTERNAL=" | cut -f2 -d= | cut -f1 -d")"`
ICOL=0
WARNING=""
echo "  // Colour traces extracted from MG5 fortran file"
echo "  vector< vector<int> > traces; traces.resize(0);"
echo "  vector<int> traceNow;"
for iLine in $traceList; do
    if [ $iLine == "PROC" ]; then	
	IGNORE="TRUE"
    elif [ $iLine == "BEGIN" ]; then	
        IGNORE="FALSE";
	echo "  traceNow.resize(0);"
        NTRACES=1
	ICOL=$((ICOL+1));
	echo "  // ICOL $ICOL"
    elif [ $iLine == "END" ]; then
	if [ $NTRACES == 1 ]; then
	    echo "  cMapSav[traceNow]=$ICOL;"
	else
	    echo "  traces.push_back(traceNow);"
	    echo "  // Traces should appear ordered by lowest first index"
	    if [ $NTRACES == 4 ]; then
		echo "  for (int i=0; i<=2; ++i) {"
		echo "    if (traces[3][0] < traces[i][0]) {"
		echo "      vector<int> tmp = traces[i];"
		echo "      traces[i] = traces[3];"
		echo "      traces[3] = tmp;"
		echo "    }"
		echo "  }"
	    fi
	    if [ $NTRACES -ge 3 ]; then
		echo "  for (int i=0; i<=1; ++i) {"
		echo "    if (traces[2][0] < traces[i][0]) {"
		echo "      vector<int> tmp = traces[i];"
		echo "      traces[i] = traces[2];"
		echo "      traces[2] = tmp;"
		echo "    }"
		echo "  }"
	    fi
	    echo "  if (traces[1][0] < traces[0][0]) {"
	    echo "    vector<int> tmp = traces[0];"
	    echo "    traces[0] = traces[1];"
	    echo "    traces[1] = tmp;"
	    echo "  }"
	    echo "  // Put elements of traces[] into traceNow in correct order"
	    echo "  traceNow=traces[0];"
	    echo "  for (int i=1; i<(int)traces.size(); ++i)"
	    echo "    traceNow.insert(traceNow.end(),traces[i].begin(),traces[i].end());"	    
	    echo "  traces.resize(0);"
	    echo "  cMapSav[traceNow]=$ICOL;"
	fi
    elif [ $IGNORE != "TRUE" ]; then 
	# zero is used to indicate end of one trace, beginning of a new
	if [ $iLine == "0" ]; then	    
     	    NTRACES=$((NTRACES+1));
	    echo "  traces.push_back(traceNow);"
	    echo "  traceNow.resize(0);"	
	else	
	    echo "  traceNow.push_back($iLine);"
	fi;
    fi;
done;
